import java.util.LinkedList;

class Graph implements IGraph {
  private LinkedList<Node> nodes;  // all the nodes in the graph
  
  Graph() {
    this.nodes = new LinkedList<Node>();
  }
  
  // adds a new node to the graph with the given string as the cityname
  public Node newNode(String cityname) {
    Node newN = new Node(cityname);
    this.nodes.add(newN);
    return newN;
  }
  
  // adds a directed edge from the "from" node to the "to" node
  public void addDirectedEdge(Node from, Node to) {
    from.addEdge(to);
  }
  
  // compute an acyclic route from "from" node to "to" node if one exists
  public LinkedList<Node> findRoute(Node from, Node to) {
    return from.findRoute(to, new LinkedList<Node>());
  }
}